static char rcsid[] = "$Id: thdprvt012.c,v 1.3 2000/07/30 13:09:31 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6 $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* threadprivate 012 :
 * threadprivate줿ѿ for directiveꤵ줿
 * for 롼פΥ롼ץ󥿤˻Ǥǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define	STRIDE		100
#define LOOPNUM		(thds * STRIDE)

int	errors = 0;
int	thds, *buf, sum;

int	x;
#pragma omp threadprivate (x)


void
clear ()
{
  int	i;


  sum = 0;
  for (i=0; i<LOOPNUM; i++) {
    buf[x] = -1;
  }
}


void
check ()
{
  int	i;


  if (sum != LOOPNUM) {
    errors += 1;
  }
  for (i=0; i<LOOPNUM; i++) {
    if (buf[i] != i % thds) {
      errors += 1;
    }
  }
}


main ()
{
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  buf = (int*) malloc (sizeof(int) * LOOPNUM);
  if (buf == NULL) {
    printf ("can not allocate memory\n");
    exit (1);
  }
  omp_set_dynamic (0);


  clear ();
  #pragma omp parallel
  {
    #pragma omp for schedule(static, 1)
    for (x=0; x<LOOPNUM; x++) {
      buf[x] = omp_get_thread_num ();
      #pragma omp critical
      sum += 1;
    }
  }
  check ();


  if (errors == 0) {
    printf ("threadprivate 012 : SUCCESS\n");
    return 0;
  } else {
    printf ("threadprivate 012 : FAILED\n");
    return 1;
  }
}
