static char rcsid[] = "$Id: set_nthrd002.c,v 1.5 2002/04/03 10:38:38 a-hasega Exp $";
/* 
 * $RWC_Release: Omni-1.6 $
 * $RWC_Copyright:
 *  Omni Compiler Software Version 1.5-1.6
 *  Copyright (C) 2002 PC Cluster Consortium
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Omni Compiler Software Version 1.0-1.4
 *  Copyright (C) 1999, 2000, 2001.
 *   Tsukuba Research Center, Real World Computing Partnership, Japan.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  
 *  $
 */
/* omp_set_num_threads : 002
 * omp_set_num_threads ǥåɿѹ,
 * omp parallel for ưǧ
 */

#include "omniConfig.h"
#include <omp.h>
#include "omni.h"


#define	LOOPNUM		(100*thds)


int
main ()
{
  int	*buf, thds, i, j, lc;

  int	errors = 0;


#if defined(__OMNI_SCASH__) || defined(__OMNI_SHMEM__)
  printf ("Omni on SCASH/SHMEM do not support omp_set_num_threads, yet.\n");
  printf ("test skipped.\n");
  exit (0);
#endif
  /* initialize */
  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi thread.\n");
    exit(0);
  }
  buf = (int *) malloc ((thds + 1) * sizeof (int));
  if (buf == NULL) {
    printf ("can not allocate memory.\n");
    exit (1);
  }
  omp_set_dynamic (0);


  for (i=1; i<=thds; i++) {

    for (j=0; j<=thds; j++) {
      buf[j] = -1;
    }

    omp_set_num_threads (i);
    #pragma omp parallel for schedule(static,1)
    for (lc=0;  lc<LOOPNUM;  lc++) {
      int no = omp_get_thread_num ();
      buf[no] = 1;

      if (omp_get_num_threads () != i) {
	#pragma omp critical
	errors += 1;
      }
    }

    /* check */
    for (j=0; j<=thds; j++) {
      if (j<i) {
	if (buf[j] != 1) {
	  errors += 1;
	}
      } else {
	if (buf[j] != -1) {
	  errors += 1;
	}
      }
    }
  }


  if (errors == 0) {
    printf ("omp_set_num_threads 002 : SUCCESS\n");
    return 0;
  } else {
    printf ("omp_set_num_threads 002 : FAILED\n");
    return 1;
  }
}
